
function Create()

	this.SubType = 1;
	chargeAmount = 0.0; --Amount of charge left. Default 0 (completely depleted, the unit has to charge before it can be used).
	maxCharge = 79.0;   --Maximum amount of charge available. Default 79.
	chargePerUse = 79.0;--Amount of the charge used per taze. Default 79 (roughly 1 game hour, for some reason), has to recharge completely after each use.
	radius = 2;         --The radius of the shock effect. Default is 2 tiles.
	
end

function Update( timePassed )

    --Must be edited here as well.
    this.Subtype = this.Subtype or 1;
	chargeAmount = chargeAmount or 0.0;
	maxCharge = maxCharge or 79.0;
	chargePerUse = chargePerUse or 79.0;
	radius = radius or 2;
    
	local on = Object.GetProperty("Triggered");
	local prisonerTazed = false;

	if chargeAmount >= chargePerUse then
		if tonumber(on) > 0 then
			local nearbyPrisoners = this.GetNearbyObjects( "Prisoner", radius );
			for prisonerName,prisonerDistance in pairs( nearbyPrisoners ) do
				prisonerName.Sound( "_Tools", "HitBy_Tazer" );
				prisonerName.StatusEffects.tazed = 60;
				if tonumber(prisonerName.Damage) < 1 then
					prisonerTazed = true;
				end
			end
		end
	end
	
	if prisonerTazed then				--If the shock barrier activates, deplete the charge by one use.
		chargeAmount = chargeAmount - chargePerUse;
	end
	
	if chargeAmount <= maxCharge then   --If the shock barrier isn't fully charged, start recharging.
		chargeAmount = chargeAmount + timePassed;
	end
	
	if chargeAmount >= chargePerUse then --If the shock barrier has enough charge for at least one use, display charged sprite.
		this.SubType = 0;                --Otherwise show uncharged sprite.
	else
		this.SubType = 1;
	end
	
end